#version 330

layout(location = 0) in vec3 vertexPosition;
layout(location = 1) in vec2 vertexTexCoord;
layout(location = 2) in vec3 vertexNormal;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;

out vec3 FragPosition;
out vec3 Normal;

void main()
{
    FragPosition = vec3(model * vec4(vertexPosition, 1.0));    // World-space position
    Normal = mat3(transpose(inverse(model))) * vertexNormal;    // Normal transformation

    gl_Position = projection * view * vec4(FragPosition, 1.0);  // Final screen position
}
